module GcDatastore
  class DatastoreFactory
    VERSION = 'v1beta2'
    @@INSTANCE = nil

    def self.get
      @@INSTANCE = new unless @@INSTANCE
      @@INSTANCE
    end

    def create(options)
      return GcDatastore::Datastore.new(newRemoteRpc(options))
    end

    def newRemoteRpc(options)
      client = makeClient(options)
      datastore = client.discovered_api('datastore', VERSION) 
      return GcDatastore::Datastore.new(GcDatastore::RemoteRpc.new(client, options))
    end

    def makeClient(options)
      client = GcDatastore::Client.new(options).authorize(options)
      return client
    end
  end
end
